//+------------------------------------------------------------------+
//|                                                  MultiWave-X.mq4 |
//|                                        Copyright  2009, PipClub |
//|                                           http://www.PipClub.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, PipClub"
#property link      "http://www.PipClub.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Black

extern int Width = 2;
extern color Color1 = Blue;
extern color Color2 = Red;
extern color Color3 = Yellow;
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double gda_104[];
double gda_108[];
double gda_112[];
double gda_116[];
double gda_120[];
double gda_unused_124[300];
double gda_unused_128[300];
double gd_unused_132 = 0.55;
int gi_unused_140 = 9500;
int gi_unused_144 = 3;
double gd_unused_148 = 0.0;
double gd_unused_156 = 0.0;
double gd_unused_164 = 0.0;
double gd_unused_172 = 0.0;
double gd_unused_180 = 0.0;
double gd_unused_188 = 0.0;
double gd_unused_196 = 0.0;
double gd_unused_204 = 0.0;
double gd_unused_212 = 0.0;
double gd_unused_220 = 0.0;
double gda_unused_228[300];
double gd_unused_232 = 0.0;

int deinit() {
   return (0);
}

int init() {
   SetIndexBuffer(0, g_ibuf_92);
   SetIndexStyle(0, DRAW_LINE, EMPTY, Width, Color1);
   SetIndexDrawBegin(0, 3);
   SetIndexLabel(0, "XWave");
   SetIndexBuffer(1, g_ibuf_96);
   SetIndexStyle(1, DRAW_LINE, EMPTY, Width, Color2);
   SetIndexDrawBegin(1, 3);
   SetIndexLabel(1, "LateBreak");
   SetIndexBuffer(2, g_ibuf_100);
   SetIndexStyle(2, DRAW_LINE, EMPTY, Width, Color3);
   SetIndexDrawBegin(2, 3);
   SetIndexLabel(2, "LCWave");
   SetLevelValue(0, 89.0);
   SetLevelValue(1, 11.0);
   SetLevelStyle(0, 1, DimGray);
   return (0);
}

int start() {
   double ld_16;
   double ld_48;
   double ld_56;
   double ld_64;
   double ld_72;
   double lda_80[];
   double lda_84[];
   double lda_88[];
   double ld_120;
   double ld_128;
   double ld_136;
   double l_ima_144;
   double l_ima_152;
   double ld_168;
   double lda_200[100];
   int l_str2time_0 = StrToTime("2010.04.30");
//   if (TimeCurrent() >= l_str2time_0) return (0);
   int li_12 = IndicatorCounted();
   int li_24 = 5;
   int l_period_28 = 3;
   int li_32 = 1;
   int li_36 = 0;
   int li_40 = 0;
   int li_44 = Bars - li_12;
   li_36 = li_24 + li_32;
   li_40 = li_36 + l_period_28;
   ArrayResize(gda_108, Bars - li_12 + 4);
   ArrayResize(gda_112, Bars - li_12 + 4);
   ArrayResize(gda_120, Bars - li_12 + 4);
   ArrayResize(gda_116, Bars - li_12 + 4);
   if (li_12 < 1) {
      for (int li_4 = 1; li_4 <= li_36; li_4++) gda_108[Bars - li_4] = 0;
      for (li_4 = 1; li_4 <= li_40; li_4++) gda_112[Bars - li_4] = 0;
   }
   li_4 = Bars - li_24;
   if (li_12 > li_24) li_4 = Bars - li_12 - 1;
   while (li_4 >= 0) {
      ld_48 = 1000000;
      for (int li_8 = li_4 + li_24 - 1; li_8 >= li_4; li_8--) {
         ld_16 = Low[li_8];
         if (ld_48 > ld_16) ld_48 = ld_16;
      }
      gda_120[li_4] = ld_48;
      li_4--;
   }
   li_4 = Bars - li_24;
   if (li_12 > li_24) li_4 = Bars - li_12 - 1;
   while (li_4 >= 0) {
      ld_56 = -1000000;
      for (li_8 = li_4 + li_24 - 1; li_8 >= li_4; li_8--) {
         ld_16 = High[li_8];
         if (ld_56 < ld_16) ld_56 = ld_16;
      }
      gda_116[li_4] = ld_56;
      li_4--;
   }
   li_4 = Bars - li_36;
   if (li_12 > li_36) li_4 = Bars - li_12 - 1;
   while (li_4 >= 0) {
      ld_64 = 0.0;
      ld_72 = 0.0;
      for (li_8 = li_4 + li_32 - 1; li_8 >= li_4; li_8--) {
         ld_64 += Close[li_8] - gda_120[li_8];
         ld_72 += gda_116[li_8] - gda_120[li_8];
      }
      if (ld_72 == 0.0) gda_108[li_4] = 100.0;
      else gda_108[li_4] = 100.0 * (ld_64 / ld_72);
      li_4--;
   }
   if (li_12 > 0) li_12--;
   li_44 = Bars - li_12;
   ArraySetAsSeries(gda_108, TRUE);
   for (li_4 = 0; li_4 < li_44; li_4++) gda_112[li_4] = iMAOnArray(gda_108, Bars, l_period_28, 0, MODE_SMA, li_4);
   int l_period_92 = 55;
   int l_period_96 = 89;
   double ld_100 = 3;
   int l_bars_108 = 300;
   ArrayResize(lda_80, Bars - li_12 + 20);
   ArrayResize(lda_84, Bars - li_12 + 20);
   bool li_192 = FALSE;
   bool li_196 = FALSE;
   if (Bars <= l_period_96) return (0);
   if (l_bars_108 == 0) l_bars_108 = Bars;
   if (li_12 < l_period_96 + l_period_92) {
      for (li_4 = 1; li_4 <= l_period_96; li_4++) lda_80[Bars - li_4] = 0.0;
      for (li_4 = 1; li_4 <= l_period_96; li_4++) lda_84[Bars - li_4] = 0.0;
   }
   int li_112 = l_bars_108 - l_period_96 - 1;
   li_192 = FALSE;
   li_196 = FALSE;
   int li_184 = 1;
   int li_188 = 1;
   double ld_176 = 2 / (ld_100 / 2.0 + 1.0);
   while (li_112 >= 0) {
      l_ima_144 = iMA(NULL, 0, l_period_92, 0, MODE_EMA, PRICE_TYPICAL, li_112);
      l_ima_152 = iMA(NULL, 0, l_period_96, 0, MODE_EMA, PRICE_TYPICAL, li_112);
      lda_200[li_184] = l_ima_144 - l_ima_152;
      ld_120 = l_ima_144 - l_ima_152;
      if (li_184 >= ld_100) {
         li_184 = 1;
         li_192 = TRUE;
      } else li_184++;
      if (li_192) {
         for (li_4 = 1; li_4 <= ld_100; li_4++) {
            if (li_4 == 1) ld_128 = lda_200[li_4];
            else
               if (ld_128 > lda_200[li_4]) ld_128 = lda_200[li_4];
            if (li_4 == 1) ld_136 = lda_200[li_4];
            else
               if (ld_136 < lda_200[li_4]) ld_136 = lda_200[li_4];
         }
         lda_84[li_112] = 100.0 * ((ld_120 - ld_128) / (ld_136 - ld_128)) + 0.01;
         li_188++;
         if (li_188 >= ld_100 / 2.0) {
            li_188 = 1;
            li_196 = TRUE;
         }
      } else lda_84[li_112] = 0;
      if (li_196) {
         ld_168 = lda_80[li_112 + 1];
         lda_80[li_112] = ld_176 * (lda_84[li_112] - ld_168) + ld_168;
      }
      li_112--;
   }
   li_44 = Bars - li_12 + 1;
   li_44 = Bars - IndicatorCounted() - 1;
   ArrayResize(lda_88, Bars - li_12 + 20);
   ArrayResize(gda_104, Bars - li_12 + 20);
   for (li_4 = 0; li_4 <= li_44; li_4++) {
      gda_104[li_4] = iCustom(NULL, 0, "LRSI", 0.55, 0, li_4);
      lda_88[li_4] = iCustom(NULL, 0, "Schaff Trend", 55, 89, 3, 0, 300, 0, li_4);
      g_ibuf_92[li_4] = (gda_112[li_4] + lda_88[li_4] + 100.0 * gda_104[li_4]) / 3.0;
      g_ibuf_96[li_4] = (lda_88[li_4] + 100.0 * gda_104[li_4]) / 2.0;
      g_ibuf_100[li_4] = iStochastic(NULL, 0, 5, 3, 1, MODE_SMA, 0, MODE_SIGNAL, li_4);
   }
   return (0);
}